
package de.ivu.elect.presentation.gebietsbaum;

import javax.annotation.Nullable;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.gebietsbaum.boundary.GebietSelectChangeEvent;
import de.ivu.elect.business.gebietsbaum.entity.Gebiet;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.faces.PreConditionCheck;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.gebietsbaum.table.AnzahlWahlberechtigteColumnBuilder;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;
import de.ivu.elect.presentation.security.AbstractGebietSecurityFilter;

@OnlineHilfeId(value = "788", mehrfachVergebenOk = true)
@Named(AnzahlWahlberechtigteSearchView.COMPONENT_NAME)
@View(viewId = AnzahlWahlberechtigteSearchView.VIEW_ID, useCase = UseCasePermission.ANZAHL_WAHLBERECHTIGTE_SEARCH)
public class AnzahlWahlberechtigteSearchView extends AbstractGebietSearchView {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "anzahlWahlberechtigteSearchView";

  public static final String VIEW_ID = "/gebietsbaum/anzahl-wahlberechtigte-search.xhtml";

  @Inject
  private transient AnzahlWahlberechtigteColumnBuilder anzahlWahlberechtigteColumnBuilder;

  public AnzahlWahlberechtigteSearchView() {
    super();
  }

  @Nullable
  @PreConditionCheck
  public String checkCondition() {
    if (!isUebergeordnetesGebietSelected()) {
      return getStartViewId();
    }

    return null;
  }

  @Override
  protected AbstractGebietSecurityFilter<Gebiet> getGebietSecurityFilter() {
    return AbstractGebietSecurityFilter.createGebietSecurityFilter(getEinsehenGebietSecurity());
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isUebergeordnetesGebietSelected() {
    return isGebietSelected();
  }

  protected Gebiet getUebergeordnetesGebiet() {
    return getSelectedGebiet();
  }

  public String getUebergeordnetesGebietName() {
    return getSelectedGebietNameFormatted();
  }

  /**
   * @deprecated To be removed...
   * @see AnzahlWahlberechtigteSearchView#initSearchParametersByContext
   */
  @Deprecated
  @Override
  public void presetSearchParameters() {
    // To be removed...
  }

  @Override
  protected void initSearchParametersByContext() {
    super.initSearchParametersByContext();

    searchParameters.setWahl(getSelectedWahl());
    searchParameters.setWahltermin(getSelectedWahltermin());
    searchParameters.setUebergeordnetesGebiet(getUebergeordnetesGebiet()); // ELECTMUC-2044
  }

  @Override
  public void addProperties(FormBuilder formBuilder) {
    // nichts zu tun
  }

  public void onGebietSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) GebietSelectChangeEvent event) {
    reset();
  }

  @Override
  public EagerLoadingCollector<Gebiet> getEagerLoadingCollector() {
    EagerLoadingCollector<Gebiet> eagerLoadingCollector = super.getEagerLoadingCollector();
    anzahlWahlberechtigteColumnBuilder.collectEagerLoadings(eagerLoadingCollector);

    return eagerLoadingCollector;
  }
}
